﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;

namespace PopulateComboBoxField
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.radDataForm.AutoGeneratingField += RadDataForm_AutoGeneratingField;
        }

        private void RadDataForm_AutoGeneratingField(object sender, Telerik.Windows.Controls.Data.DataForm.AutoGeneratingFieldEventArgs e)
        {
            var dataForm = sender as RadDataForm;
            var vm = dataForm.DataContext as MyViewModel;
            if (e.PropertyName == "CountryID")
            {
                var binding = new Binding("Countries") { Source = vm };
                e.DataField = new DataFormComboBoxField()
                {
                    Label = "Country",
                    SelectedValuePath = "ID",
                    DisplayMemberPath = "Name",
                    DataMemberBinding = new Binding("CountryID") { Mode = BindingMode.TwoWay }
                };

                e.DataField.SetBinding(DataFormComboBoxField.ItemsSourceProperty, binding);
            }
        }
    }
}
