﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace PopulateComboBoxField
{
    public class MyViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        private ObservableCollection<Club> clubs;
        private ObservableCollection<Player> players;
        private object selectedItem;
        private ObservableCollection<Country> countries;
        public ICommand AddItemToComboBoxCommand { get; set; }

        public MyViewModel()
        {
            this.AddItemToComboBoxCommand = new DelegateCommand(OnAddItemToComboBoxCommandExecuted);
        }

        private void OnAddItemToComboBoxCommandExecuted(object obj)
        {
            var radDataForm = obj as RadDataForm;
            this.countries.Add(new Country() { ID = 5, Name = "Spain" });
            this.countries.Add(new Country() { ID = 6, Name = "Germany" });
        }

        public ObservableCollection<Country> Countries
        {
            get
            {
                if (this.countries == null)
                {
                    this.countries = new ObservableCollection<Country>();
                    this.countries.Add(new Country() { ID = 1, Name = "USA" });
                    this.countries.Add(new Country() { ID = 2, Name = "Italy" });
                    this.countries.Add(new Country() { ID = 3, Name = "France" });
                    this.countries.Add(new Country() { ID = 4, Name = "Canada" });
                }

                return this.countries;
            }
        }

        public ObservableCollection<Club> Clubs
        {
            get
            {
                if (this.clubs == null)
                {
                    this.clubs = Club.GetClubs();
                }

                return this.clubs;
            }
        }

        public ObservableCollection<Player> Players
        {
            get
            {
                if (this.players == null)
                {
                    this.players = Player.GetPlayers();
                }

                return this.players;
            }
        }

        public object SelectedItem
        {
            get { return this.selectedItem; }
            set
            {
                if (value != this.selectedItem)
                {
                    this.selectedItem = value;
                    this.OnPropertyChanged("SelectedItem");
                }
            }
        }

        protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, args);
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
    }
}
